package com.ningdatech.pmapi.filemanage.manage;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ningdatech.basic.model.PageVo;
import com.ningdatech.pmapi.filemanage.model.param.ProjectFileListParam;
import com.ningdatech.pmapi.filemanage.model.vo.ProjectFileListVO;
import com.ningdatech.pmapi.filemanage.model.vo.ProjectFileVO;
import com.ningdatech.pmapi.projectlib.model.entity.Project;
import com.ningdatech.pmapi.projectlib.service.IProjectService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @Classname ProjectFileManage
 * @Description
 * @Date 2023/6/6 16:04
 * @Author PoffyZhang
 */
@Component
@AllArgsConstructor
@Slf4j
public class ProjectFileManage {

    private final IProjectService projectService;

    public PageVo<ProjectFileListVO> list(ProjectFileListParam param) {
        Page<Project> page = param.page();
        projectService.page(page,Wrappers.lambdaQuery(Project.class)
                .like(StringUtils.isNotBlank(param.getProjectName()),Project::getProjectName,param.getProjectName())
                .like(StringUtils.isNotBlank(param.getBuildOrgName()),Project::getBuildOrgName,param.getBuildOrgName())
                .orderByDesc(Project::getUpdateOn));

        if(0L == page.getTotal()){
            return PageVo.empty();
        }
        List<ProjectFileListVO> vos = page.getRecords().stream().map(p -> {
            ProjectFileListVO vo = new ProjectFileListVO();
            vo.setId(p.getId());
            vo.setCanRead(Boolean.TRUE);
            vo.setBuildOrgName(p.getBuildOrgName());
            vo.setPojectCode(p.getProjectCode());
            vo.setProjectName(p.getProjectName());
            return vo;
        }).collect(Collectors.toList());
        return PageVo.of(vos,page.getTotal());
    }

    public ProjectFileVO file(Long projectId) {
        return null;
    }

    public String wantRead(Long projectId) {
        return "申请成功";
    }
}
